<!DOCTYPE html>
<html>
  <head>

    <title>Polyline visualiser</title>

    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" integrity="sha384-VzLXTJGPSyTLX6d96AxgkKvE/LRb7ECGyTxuwtpjHnVWVZs2gp5RDjeM/tgBnVdM" crossorigin="anonymous">
    <link rel="stylesheet" href="https://unpkg.com/leaflet-easybutton@2.4.0/src/easy-button.css" integrity="sha384-iNk4bdiUuP4VWx8c4KVwk07wshEQVvAe/8xwpcNR/5anLhH9SFPHkjLSXAwGwXKC" crossorigin="anonymous">
    <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js" integrity="sha384-RFZC58YeKApoNsIbBxf4z6JJXmh+geBSgkCQXFyh+4tiFSJmJBt+2FbjxW7Ar16M" crossorigin="anonymous"></script>
    <script src="https://unpkg.com/polyline-encoded@0.0.9/Polyline.encoded.js" integrity="sha384-Unn6s4TuHyJguuREG7OCHeFEG3FhZ8dS8er0GGMt7mUzkyM0O/VpRwuKSTEbzVvu" crossorigin="anonymous"></script>
    <script src="https://unpkg.com/js-base64@2.5.2/base64.js" integrity="sha384-TtY98uFZuJHTdPxnI7Jhz1LqitA4r51jGEU+viAwGaK+yTMoc2WI2bnTTbX/bxT0" crossorigin="anonymous"></script>
    <script src="https://unpkg.com/leaflet-easybutton@2.4.0/src/easy-button.js" integrity="sha384-pQbeNTZ2fXhFbWb5OozBmu5GVW/mHkxUgFn/3PNt4RPm4IJ98yJSTGu/8LR53NuV" crossorigin="anonymous"></script>
    <script src="https://unpkg.com/leaflet-polylinedecorator@1.6.0/dist/leaflet.polylineDecorator.js" integrity="sha384-FhPn/2P/fJGhQLeNWDn9B/2Gml2bPOrKJwFqJXgR3xOPYxWg5mYQ5XZdhUSugZT0" crossorigin="anonymous"></script>

    <style>
    html, body {
      height: 100%;
      margin: 0;
    }

    #map {
      width: 100%;
      height: 100%;
    }

    </style>


  </head>
  <body>

    <div id='map'>
    </div>

    <script type="text/javascript">

      var map = L.map('map', {
        center: [0,0],
        zoom: 3
      });


      // satellite
      L.tileLayer('https://api.maptiler.com/maps/basic/{z}/{x}/{y}.png?key=HrARH01SH6sg5I6HoXdU', {
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.maptiler.com/">Maptiler</a>',
        maxZoom: 18,
        id: 'mapbox/streets-v11',
        tileSize: 512,
        zoomOffset: -1,
        accessToken: 'pk.eyJ1IjoibGVvbmFyZGVocmVuZnJpZWQiLCJhIjoiY2l1ZWk1cjlsMDAxZTJ2cWxmNHowbmVvdCJ9.jd86A83HNqNlNyjRY0iGIg'
      }).addTo(map);


      const color = "#f30";
      const addPolyline = (line) => {
        const polyline = L.Polyline.fromEncoded(line, {
          weight: 2,
          color: color
        }).addTo(map);

        var decorator = L.polylineDecorator(polyline, {
          patterns: [
            // defines a pattern of 10px-wide dashes, repeated every 20px on the line
            {offset: 50, repeat: 400, symbol: L.Symbol.arrowHead({pathOptions: {fillOpacity: 0.7, weight: 0, color: color}})}
          ]
        }).addTo(map);

        map.fitBounds(polyline.getBounds());
      };

      const urlParams = new URLSearchParams(window.location.search);
      const encoded = urlParams.get('polyline');

      if(encoded) {
        addPolyline(encoded);
      };

      const base64 = urlParams.get('polylineBase64') || urlParams.get('base64');

      if(base64) {
        console.log(base64);
        var line = Base64.decode(base64);
        console.log(line);
        addPolyline(line);
      };

      L.easyButton(`<span title="Shorten URL with tinyurl.com">&#9986;</span>`, function(btn, map){
        const url = `https://tinyurl.com/api-create.php?url=${window.location.href}`;
        window.open(url, "_blank");
      }).addTo(map);

      L.easyButton(`<span title="Help">&#x2139;</span>`, function(btn, map){
        const url = "https://gitlab.com/leonard.ehrenfried/polyline-visualiser";
        window.open(url, "_blank");
      }).addTo(map);


    </script>

  </body>
</html>

